<script setup lang="ts">
    import { graphql } from "./../gql/index";
    import { computed } from "vue";
    import { useQuery } from "@vue/apollo-composable";
    import useNavigationStore, { defaultTabBase } from "./../stores/navigation";
    import useAuthStore from "./../stores/auth";
    import AddInstructorToEvent from "./RegisterCards/AddInstructorToEvent.vue";
    import BaseData from "./RegisterCards/InstructorBaseData.vue";
    import ExtensionData from "./RegisterCards/InstructorExtensionData.vue";
    import InstructorZirkelData from "./RegisterCards/InstructorZirkelData.vue";
    import { DynamicRoutePaths } from "../plugins/router";
    import { useRouter } from "vue-router";

    const navigationStore = useNavigationStore();
    const authStore = useAuthStore();
    const router = useRouter();

    navigationStore.$subscribe((_mutation, _state) => {
        router.push({ name: DynamicRoutePaths.InstructorDetails }); // TODO move this out possibly
    });

    // graphql
    const instructorQueryVariables = computed(() => {
        return {
            id: navigationStore.instructorId,
        };
    });
    const instructorQuery = graphql(`
        query InstructorQuery($id: Uuid = "00000000-0000-0000-0000-000000000000") {
            instructor(id: $id) {
                id
                familyName
                callName
                extensions {
                    id
                    event {
                        id
                        name
                        year
                        startDate
                    }
                }
            }
        }
    `);
    const { result: resultInstructor } = useQuery(instructorQuery, instructorQueryVariables, {
        fetchPolicy: "cache-and-network",
    });
    const instructor = computed(() => {
        return resultInstructor.value?.instructor!;
    });

    // computed value extractions
    const tabs = computed(() => {
        const extensions = instructor?.value?.extensions! ?? [];
        let res = [];

        for (const extension of extensions ?? []) {
            res.push({
                extension_id: extension.id,
                event_name: extension.event?.name ?? "",
                event_year: extension.event?.year ?? 0,
                event_id: extension.event?.id,
                event_startDate: extension.event?.startDate,
            });
        }

        // more recent events are more to the left
        res.sort((a, b) => {
            return b.event_startDate.localeCompare(a.event_startDate);
        });

        return res;
    });
</script>

<template>
    <div class="pa-3">
        <h2 class="text-center">Zirkelleiter</h2>

        <v-card v-if="instructor && instructor != null" variant="tonal" class="my-2">
            <template v-slot:title> Zirkelleiter: {{ instructor.callName }} {{ instructor.familyName }} </template>
            <template v-slot:text>
                <v-tabs v-model="navigationStore.instructorViewTab">
                    <v-tab :value="defaultTabBase"> Stammdaten </v-tab>
                    <v-tab value="zirkel"> Zirkel </v-tab>
                    <v-tab value="add" v-if="authStore.hasWriteInstructor">
                        <span class="material-symbols-outlined"> add </span>
                    </v-tab>
                    <v-tab v-for="tab in tabs" :value="tab.event_id">{{ tab.event_name }} ({{ tab.event_year }})</v-tab>
                </v-tabs>

                <v-card-text>
                    <v-window v-model="navigationStore.instructorViewTab">
                        <v-window-item :value="defaultTabBase">
                            <h2 class="mb-5">Stammdaten:</h2>
                            <BaseData></BaseData>
                        </v-window-item>
                        <v-window-item value="zirkel">
                            <h2 class="mb-5">Zirkel:</h2>
                            <InstructorZirkelData></InstructorZirkelData>
                        </v-window-item>
                        <v-window-item value="add" v-if="authStore.hasWriteInstructor">
                            <h2 class="mb-5">Füge Zirkelleiter zu Veranstaltung hinzu:</h2>
                            <AddInstructorToEvent></AddInstructorToEvent>
                        </v-window-item>
                        <v-window-item v-for="tab in tabs" :value="tab.event_id">
                            <h2 class="mb-5">
                                {{ instructor.callName }} {{ instructor.familyName }}: {{ tab.event_name }} ({{ tab.event_year }})
                            </h2>
                            <ExtensionData :extension-id="tab.extension_id"></ExtensionData>
                        </v-window-item>
                    </v-window>
                </v-card-text>
            </template>
        </v-card>
    </div>
</template>
